	.dbfile C:\iccv7arm\MICROM~1\MICROB~4\MicroBoltHelloWorld.c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;          Count -> R6
;          Delay -> R7
_main:
	stmfd R13!,{R14}
	.dbline -1
	.dbline 42
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBoltHelloWorld.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 4/2/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	1 - Initial		
; |                 : 2 - Add printf functionality																																																				
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include <STDIO.h>
; 
; #include "MicroBoltHelloWorld.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; extern int _textmode;		                        // This is defined in the ICCARM library 
; 		
; void main(void)
;   {
	.dbline 51
; 
; /*
; |----------------------------------------------------
; |     MicroBolt hardware setup 
; |----------------------------------------------------
; */
; 
;   unsigned int Delay; 
;   unsigned int Count = 0;
	mov R6,#0
	.dbline 53
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 60
; 
; /*
; |-------------------------
; | Config MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R4,#0
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 61
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R4,#4
	ldr R5,LIT_main+4
	str R4,[R5,#0]
	.dbline 63
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R4,#2
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 70
; 
; /*
; |-------------------------
; | Config PLL 
; |-------------------------
; */
;   VICVectAddr8 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R4,LIT_main+8
	ldr R5,LIT_main+12
	str R4,[R5,#0]
	.dbline 71
;   VICVectCntl8 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R4,#44
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 72
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R4,#4096
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 74
; 
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+24
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 75
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R4,LIT_main+28
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 76
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R4,#170
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 77
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R4,#85
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 84
; 
; /*
; |-------------------------
; | Config GPIO 
; |-------------------------
; */
;   PCB_PINSEL0=0x00000000;                       // JTAG is via secondary port
	mov R4,#0
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 85
;   PCB_PINSEL1=0x55400000;
	ldr R4,LIT_main+40
	ldr R5,LIT_main+44
	str R4,[R5,#0]
	.dbline 87
;  
;   GPIO_IODIR=(0x00000000<<16)|                  // Make all inputs to start with
	mov R4,#0
	ldr R5,LIT_main+48
	str R4,[R5,#0]
	.dbline 90
; 	     0x00000000;
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+48
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 97
; 
; /*
; |-------------------------
; | Config UART-O 
; |-------------------------
; */
;   PCB_PINSEL0 |= P0_0_UART_0_TX;                // Setup P0.0 to alternate function UART0-TX
	ldr R4,LIT_main+36
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 97
	.dbline 99
; 
;   UART0_LCR = 0x00000083;	 	                    // Enable the divisor
	mov R4,#131
	ldr R5,LIT_main+52
	str R4,[R5,#0]
	.dbline 100
;   UART0_DLM = 0;				                        // Divisor latch MSB (for baud rates < 4800) 
	mov R4,#0
	ldr R5,LIT_main+56
	str R4,[R5,#0]
	.dbline 101
;   UART0_DLL = BAUD_RATE_115200;			            // Divisor latch LSB 
	mov R4,#8
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 102
;   UART0_LCR = 0x00000003;  	                    // Close LCR, now UART works with divisor
	mov R4,#3
	ldr R5,LIT_main+52
	str R4,[R5,#0]
	.dbline 104
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	b L3
L2:
	.dbline 113
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
; 
;   while(1)                                            // Do this forever
;     {
	.dbline 114
;     Count++;                                          // Increment test counter
	add R6,R6,#1
	.dbline 116
; 
;     printf("Hello World...%d", Count);                // Output string via UART-0
	ldr R0,LIT_main+64
	mov R1,R6
	bl _printf
	.dbline 117
;     GPIO_IOSET = MICROBOLT_LED;                       // MicroBolt LED On
	mov R4,#4194304
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 118
	mov R7,#0
	b L9
L6:
	.dbline 118
L7:
	.dbline 118
	add R7,R7,#1
L9:
	.dbline 118
;     for (Delay = 0; Delay < 3700000; Delay++);        // Delay for 1/2 Second
	ldr R4,LIT_main+72
	cmp R7,R4
	blo L6
	.dbline 120
; 
;     printf("...from MicroBolt!\n", Count);            // Output string via UART-0 
	ldr R0,LIT_main+76
	mov R1,R6
	bl _printf
	.dbline 121
;     GPIO_IOCLR = MICROBOLT_LED;                       // MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+80
	str R4,[R5,#0]
	.dbline 122
	mov R7,#0
	b L14
L11:
	.dbline 122
L12:
	.dbline 122
	add R7,R7,#1
L14:
	.dbline 122
	ldr R4,LIT_main+72
	cmp R7,R4
	blo L11
	.dbline 123
L3:
	.dbline 112
	b L2
X0:
	.dbline -2
L1:
	ldmfd R13!,{R15}
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD _pll_isr
	DCD -3808
	DCD -3552
	DCD -4080
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536821748
	DCD -536821756
	DCD -536821760
	DCD L5
	DCD -536707068
	DCD 3700000
	DCD L10
	DCD -536707060
	.dbsym r Count 6 i
	.dbsym r Delay 7 i
	.dbend
	EXPORT _putchar
	.dbfunc e putchar _putchar fI
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;     SerialByte -> R6
_putchar:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R11,R12,R14}
	mov R11,R13
	mov R6,R0
	.dbline -1
	.dbline 137
;     for (Delay = 0; Delay < 3700000; Delay++);        // Delay for 1/2 Second           
;     }
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   putchar
; |     Inputs          :   Byte for transmission
; |     Outputs         :   None
; |     Purpose         :   Transmit a byte via UART0 to enable printf
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; int putchar(char SerialByte)
;   {
	.dbline 138
;   _textmode = 1;                                      // Turn carriage return line feed on for printf
	mov R4,#1
	ldr R5,LIT_putchar+0
	str R4,[R5,#0]
	.dbline 139
;   if (_textmode == 1 && SerialByte == '\n')
	ldr R4,LIT_putchar+0
	ldr R4,[R4,#0]
	cmp R4,#1
	bne L19
	and R4,R6,#255
	cmp R4,#10
	bne L19
	.dbline 140
;       {
	.dbline 141
;       putchar('\r');
	mov R0,#13
	bl _putchar
	.dbline 142
;       }
L18:
	.dbline 143
L19:
	.dbline 143
;   while (!(UART0_LSR & 0x20)); 
	ldr R4,LIT_putchar+4
	ldr R4,[R4,#0]
	tst R4,#32
	beq L18
	.dbline 144
;   UART0_THR = SerialByte;
	and R4,R6,#255
	ldr R5,LIT_putchar+8
	str R4,[R5,#0]
	.dbline 145
;   return SerialByte;
	and R0,R6,#255
	.dbline -2
L15:
	ldmfd R11,{R4,R5,R6,R11,SP,PC}
	.dbline 0 ; func end
LIT_putchar:
	DCD __textmode
	DCD -536821740
	DCD -536821760
	.dbsym r SerialByte 6 c
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 161
;   }
; 
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler pll_isr
; void pll_isr(void)
;   {
	.dbline 162
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 163
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 164
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 165
;   VICIntEnClear = PLL_CLR;                      // Disable the PLL interrupt, not needed anymore
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 166
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L21:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	IMPORT __textmode
	AREA	"C$$code", CODE, READONLY
L10:
	DCB "...from MicroBolt!", 10, 0
L5:
	DCB "Hello World...%d", 0
	END
